﻿using Modbus.Device;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp8
{
    public partial class Form1 : Form
    {
        SerialPort port = new SerialPort();
        private bool is_running = false;
        public Form1()
        {
            InitializeComponent();
            label1.Text = "Порт закрыт";
            label2.Text = "опроса остановлен";
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        // Открытие COM-порта
        private void button1_Click(object sender, EventArgs e)
        {
            if (port.IsOpen == false)
            {
                port = new SerialPort("COM2", 9600, Parity.Even, 7, StopBits.One);
                port.Open();
                label1.Text = "Порт открыт";
            }
        }

        // Закрытие COM-порта
        private void button2_Click(object sender, EventArgs e)
        {
            if (port.IsOpen == true)
            {
                port.Close();
                label1.Text = "Порт закрыт";
            }
        }

        // Начало опроса
        private void button3_Click(object sender, EventArgs e)
        {
            label2.Text = "опроса идет";
            is_running = true;
            ThreadPool.QueueUserWorkItem((useless) =>
            {
                while (is_running)
                {
                    if (port.IsOpen == true)
                    {
                        ModbusSerialMaster master = ModbusSerialMaster.CreateAscii(port);
                        ushort startAddress = 4099;     // Начальный адрес
                        ushort numInputs = 1;       // Количество регистров для запроса          
                        ushort[] inputs;
                        try
                        {
                            inputs = master.ReadHoldingRegisters(16, startAddress, numInputs);
                        }
                        catch (Exception ex)
                        {
                            textBox1.Text = ex.Message;
                            break;
                        }
                        foreach (ushort input in inputs)
                        {
                            this.Invoke((System.Action)(() =>
                            {
                                textBox1.Clear();
                                textBox1.Text += input.ToString() + "\t";
                                chart1.Series["Series1"].Points.Add(input);
                            }));
                        }
                        Thread.Sleep(1000);
                    }
                }
            });
        }

        // Остановка опроса
        private void button4_Click(object sender, EventArgs e)
        {
            is_running = false;
            textBox1.Clear();
            label2.Text = "опроса остановлен";
        }
    }
}
